/**************************************************************************/
/*									  */
/* Copyright (c) 2000-2005 by Alexandr V. Shutko, Khabarovsk, Russia	  */
/* All rights reserved.							  */
/*									  */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*									  */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/* Table for encoding/decoding 						  */
/* This table required for V5 packet encryption. The inclusion of this 	  */
/* data is intended to constitute "fair use" under U.S and international  */
/* copyright laws.					  		  */
/*                                                                        */
/* $Id: v5crypt.h,v 1.4 2005/01/05 05:19:38 regress Exp $		  */
/**************************************************************************/


const unsigned char v5table [] = 
{
   0x59, 0x60, 0x37, 0x6B, 0x65, 0x62, 0x46, 0x48, 
   0x53, 0x61, 0x4C, 0x59, 0x60, 0x57, 0x5B, 0x3D,
   0x5E, 0x34, 0x6D, 0x36, 0x50, 0x3F, 0x6F, 0x67, 
   0x53, 0x61, 0x4C, 0x59, 0x40, 0x47, 0x63, 0x39,
   0x50, 0x5F, 0x5F, 0x3F, 0x6F, 0x47, 0x43, 0x69, 
   0x48, 0x33, 0x31, 0x64, 0x35, 0x5A, 0x4A, 0x42,
   0x56, 0x40, 0x67, 0x53, 0x41, 0x07, 0x6C, 0x49, 
   0x58, 0x3B, 0x4D, 0x46, 0x68, 0x43, 0x69, 0x48,
   0x33, 0x31, 0x44, 0x65, 0x62, 0x46, 0x48, 0x53, 
   0x41, 0x07, 0x6C, 0x69, 0x48, 0x33, 0x51, 0x54,
   0x5D, 0x4E, 0x6C, 0x49, 0x38, 0x4B, 0x55, 0x4A, 
   0x62, 0x46, 0x48, 0x33, 0x51, 0x34, 0x6D, 0x36,
   0x50, 0x5F, 0x5F, 0x5F, 0x3F, 0x6F, 0x47, 0x63, 
   0x59, 0x40, 0x67, 0x33, 0x31, 0x64, 0x35, 0x5A,
   0x6A, 0x52, 0x6E, 0x3C, 0x51, 0x34, 0x6D, 0x36, 
   0x50, 0x5F, 0x5F, 0x3F, 0x4F, 0x37, 0x4B, 0x35,
   0x5A, 0x4A, 0x62, 0x66, 0x58, 0x3B, 0x4D, 0x66, 
   0x58, 0x5B, 0x5D, 0x4E, 0x6C, 0x49, 0x58, 0x3B,
   0x4D, 0x66, 0x58, 0x3B, 0x4D, 0x46, 0x48, 0x53, 
   0x61, 0x4C, 0x59, 0x40, 0x67, 0x33, 0x31, 0x64,
   0x55, 0x6A, 0x32, 0x3E, 0x44, 0x45, 0x52, 0x6E, 
   0x3C, 0x31, 0x64, 0x55, 0x6A, 0x52, 0x4E, 0x6C,
   0x69, 0x48, 0x53, 0x61, 0x4C, 0x39, 0x30, 0x6F, 
   0x47, 0x63, 0x59, 0x60, 0x57, 0x5B, 0x3D, 0x3E,
   0x64, 0x35, 0x3A, 0x3A, 0x5A, 0x6A, 0x52, 0x4E, 
   0x6C, 0x69, 0x48, 0x53, 0x61, 0x6C, 0x49, 0x58,
   0x3B, 0x4D, 0x46, 0x68, 0x63, 0x39, 0x50, 0x5F, 
   0x5F, 0x3F, 0x6F, 0x67, 0x53, 0x41, 0x25, 0x41,
   0x3C, 0x51, 0x54, 0x3D, 0x5E, 0x54, 0x5D, 0x4E, 
   0x4C, 0x39, 0x50, 0x5F, 0x5F, 0x5F, 0x3F, 0x6F,
   0x47, 0x43, 0x69, 0x48, 0x33, 0x51, 0x54, 0x5D, 
   0x6E, 0x3C, 0x31, 0x64, 0x35, 0x5A, 0x00, 0x00 
};

